/*
 * B2M_Axes.c
 * velocity profile planner for Beamicon2 Modular
 * stripped down to absolute minimum for debugging
 *
 * Created: 17-Nov-2022
 *  Author: Bene
 */ 


#include "B2M_Axes.h"
#include <stdio.h>
#include <math.h>
#include <string.h> // memcpy(), memset()


AxisBuffEntry AxisBuffer[AXIS_BUFFER_SIZE];
AxisBuffEntry* buf1; // Interpolation zw. 2 Puffern
AxisBuffEntry* buf2;

fixp32_t currVel; // 1.0
fixp32_t maxVel;  // 1.5
fixp32_t actOvr;  // 1.0
fixp32_t nomAcc;  // 0.05
fixp32_t halfAcc; // 0.025
fixp32_t halfAcc2;
fixp32_t eStopAcc;// 0.1

int wrIndex;
int rdIndex;
int bufGauge;

int32_t nomPos[MAX_NUMAXES]; // ungefilterte Position
int32_t lastPos[MAX_NUMAXES];

#define _BAUD 	  230400	// serial debug port

void ClearBuffer ()
{
    currVel= 0;
    wrIndex = 1;
    rdIndex = 0;
    //PutPosDat (nomPos, GetRefNum ());
    buf1= &AxisBuffer[rdIndex];
    buf1->vNom= 0;
    buf1->vMax= maxVel;
    buf2= buf1;
    bufGauge= 1;
    printf ("ClearBuffer() buf1=%X vn=%X", buf1, buf1->vNom);
}

void Init_Axes ()
{
  //_setbaud(_BAUD);
  //_waitms(100);
	currVel = 0x40000000; // 1.0
	maxVel  = 0x60000000; // 1.5
	SetAcceleration (0x03333333, 0x06666666); // 0.05, 0.1
	//memset (nomPos, 0, MAX_NUMAXES*4);
	ClearBuffer ();
}

void SetVelocity (fixp32_t v)
{
  currVel= v;
}

void SetAcceleration (fixp32_t aNom, fixp32_t aEstop)
{
  nomAcc= aNom;
  halfAcc= aNom >> 1;
  halfAcc2= FixpMul (halfAcc, halfAcc);
  eStopAcc= aEstop;
}


fixp32_t FixpMul (fixp32_t a, fixp32_t b)
{
    uint64_t r = a;
    r*= b;
    return r>>30;
}


void DumpBuffer ()
{
  printf ("AxisBuffer = %08X", &AxisBuffer);
  printf (" size = %d\n", sizeof(AxisBuffEntry));
  for (int i=0; i<wrIndex; i++)
  {
    AxisBuffEntry* buf= &AxisBuffer[i];
    printf ("buffer[%d] vn=%08X vm=%08X dd=%08X_%08X\n", i, buf->vNom, buf->vMax, (uint32_t)(buf->dDec>>32), (uint32_t)(buf->dDec));
  }
}


void Test ()
{
	  _setbaud(_BAUD);
	  _waitms(100);
    SetVelocity (0x40000000);
    DumpBuffer ();
}
