/*
 * B2M_Axes.h
 * Bahn- und Rampenplanung für Beamicon-Modular
 *
 * Created: 13.11.2020 18:37:51
 *  Author: Bene
 */ 


#ifndef AXES_H_
#define AXES_H_

#include <stdint.h>
#include <stdbool.h>

#define MAX_NUMAXES        10
#define AXIS_BUFFER_SIZE   512
#define FILTER_BUFFER_SIZE 256

typedef uint32_t fixp32_t;
typedef struct {
	int32_t  pos[MAX_NUMAXES];
	fixp32_t vNom; // Pufferdistanz normiert 0..1
	fixp32_t vMax; // Maximalgeschwindigkeit zB. 150%
	uint64_t dDec; // aufsummierter Bremsweg bis Rampe Ende
	int16_t  ref;
    int16_t  ioCmd;
    int32_t  ioDat;
} AxisBuffEntry;

void Init_Axes () __fromfile ("B2M_Axes.c");
void ClearBuffer () __fromfile ("B2M_Axes.c");
void SetVelocity (fixp32_t v) __fromfile ("B2M_Axes.c");
void SetAcceleration (fixp32_t aNom, fixp32_t aEstop) __fromfile ("B2M_Axes.c");
void SetFilter (int vf, int pf) __fromfile ("B2M_Axes.c");
void SetFeedOverride (fixp32_t ovr) __fromfile ("B2M_Axes.c");
void EmergencyStop () __fromfile ("B2M_Axes.c");
void PutPosDat (int32_t* data, int16_t ref) __fromfile ("B2M_Axes.c");
void DoInterpolation () __fromfile ("B2M_Axes.c");
int16_t GetRefNum () __fromfile ("B2M_Axes.c");
int32_t GetAxisPos (int a) __fromfile ("B2M_Axes.c");
void GetAllPositions (int32_t* array) __fromfile ("B2M_Axes.c");
bool IsMoving () __fromfile ("B2M_Axes.c");
int GetBufGauge () __fromfile ("B2M_Axes.c");

void Test () __fromfile ("B2M_Axes.c");

#endif /* AXES_H_ */
